/*
 * SWE-Praktikum: Freiburg
 * 
 * Letztes Aenderungsdatum: $Date: 2015-12-06 23:42:32 +0100 (So, 06 Dez 2015) $
 * Letzte  Revision:        $Revision: 1100 $
 * Zuletzt geaendert von:   $Author: stervoir $
 * 
 */


#include "Finanzen.h"
#include <cmath>

Finanzen::Finanzen() {
}

Finanzen::Finanzen(tm date, int64_t umsatz, int64_t gewinn, int64_t bilanzsumme, int64_t eigenkapital, double EUR, double USD) {
    setAttr(date, umsatz, gewinn, bilanzsumme, eigenkapital, EUR, USD);
}

/*finance::finance(const finance& orig) {
}*/

Finanzen::~Finanzen() {
}

void Finanzen::setAttr(tm date, int64_t umsatz, int64_t gewinn, int64_t bilanzsumme, int64_t eigenkapital, double EUR, double USD) {
    this->date = date;
    this->umsatz = umsatz;
    this->gewinn = gewinn;
    this->bilanzsumme = bilanzsumme;
    this->eigenkapital = eigenkapital;
    this->konv[0] = EUR;
    this->konv[1] = USD;
}

void Finanzen::testoutput() {
    cout << setw(2) << right << setfill('0') << date.tm_mday << "-" <<
            setw(2) << right << date.tm_mon + 1 << "-" <<
            setw(2) << right << date.tm_year + 1900 << endl;
    /*
    long umsatz;
    long gewinn;
    long bilanzsumme;
    long eigenkapital;
     */
    cout << umsatz << endl;
    cout << gewinn << endl;
    cout << bilanzsumme << endl;
    cout << eigenkapital << endl;

}

bool Finanzen::getVorhersage() {
    return vorhersage;
}
int64_t Finanzen::getUmsatz() {
    return umsatz;
};

int64_t Finanzen::getGewinn() {
    return gewinn;
};

int64_t Finanzen::getBilanzsumme() {
    return bilanzsumme;
};

int64_t Finanzen::getEigenkapital() {
    return eigenkapital;
};

double Finanzen::getEKAnteil() {
    double eka;
    eka= ((double)eigenkapital)/bilanzsumme;
    eka=eka*1000.0;
    eka=rint(eka);
    eka=eka/1000.0;
    return eka;
};

double Finanzen::getUmsatzrendite() {
    double ur;
    ur=((double) gewinn)/umsatz;
         
        ur=ur*1000.0;
        ur= rint(ur);
        ur=ur/1000.0;
    
    return ur;
};

double Finanzen::getKonv(int i) {
    return konv[i];
}


void Finanzen::setVorhersage(bool a) {
    vorhersage = a;
}

tm Finanzen::getDatum() {
    
  return date;  
};