/*
 * SWE-Praktikum: Freiburg
 * 
 * Letztes Aenderungsdatum: $Date: 2016-01-09 17:57:00 +0100 (Sa, 09 Jan 2016) $
 * Letzte  Revision:        $Revision: 1661 $
 * Zuletzt geaendert von:   $Author: stvaklei $
 * 
 */


#include "Firma.h"

Firma::Firma() {
}

Firma::Firma(string name, vector<Finanzen> f) {
    this->name = name;
    this->daten = f;
    setCAGRUmsatz();
    setCAGRGewinn();
   
  //  setVorhersage();
    }

Firma::Firma(const Firma& obj) {
    
  name = obj.name;
  daten = obj.daten;
  cagru = obj.cagru;
  cagrg = obj.cagrg;  
  mGewinnl = obj.mGewinnl;//m=Steigung Lin Reg
  mUmsatzl = obj.mUmsatzl;//m=Steigung Lin Reg
  mBilnazsummel = obj.mBilnazsummel;//m=Steigung Lin Reg
  mEigenkapitall = obj.mEigenkapitall; //m=Steigung Lin Reg
  bGewinnl = obj.bGewinnl;//y-Achsenabschnitt LinReg
  bUmsatzl = obj.bUmsatzl;//y-Achsenabschnitt LinReg
  bBilanzsummel = obj.bBilanzsummel;//y-Achsenabschnitt LinReg
  bEigenkapital = obj.bEigenkapital; //y-Achsenabschnitt LinReg
}


 void Firma::setAttr(string name, vector<Finanzen> f) {
    this->name = name;
    this->daten = f;
    setMGewinn();
    setMUmsatz();
    setMBilanzsumme();
    setMEigenkapital();
    setCAGRUmsatz();
//  
  setCAGRGewinn();
}
  


   
void Firma::setMGewinn(){
      
 //Durchsnitt Jahre errechnen
   double jahre;
  // 
 jahre = ((double)daten.at(0).getDatum().tm_year) + 1900.0;
    
    for (int k = 1; k < daten.size(); k++) {
      jahre = jahre + ((double)daten.at(k).getDatum().tm_year) + 1900.0;
    }
   
  // cout <<jahre <<" Jahre"<<endl;
    
   double xStrich; // Durchschnitt JAhre
    xStrich = jahre / ((double)daten.size());
   
// Durchschnitt Gewinn errechnen
    int64_t gewinne;
    gewinne = daten.at(0).getGewinn();
for (int k = 1; k < daten.size(); k++) {
        gewinne = gewinne + daten.at(k).getGewinn();
    
    }

int64_t yStrich; // Durchschnitt Gewinn
    yStrich = gewinne / daten.size();
     
 
//cout <<"------------------------------------2---------------------------"<<endl;
    //lineare Regression
    vector<double> x; //Jahre - Durschnitt Jahre
    vector<double> xx; //zum Quadrat
    vector<int64_t> y; //Gewinn - Durschnitt Gewinn
    vector<int64_t> xy; // x * y
    
    double SummeXX;
int64_t SummeXY;

    x.push_back((daten.at(0).getDatum().tm_year + 1900) - xStrich);
     //cout << "x: "<<x.at(0)<<endl;
    for (int k = 1; k < daten.size(); k++) {
        x.push_back((daten.at(k).getDatum().tm_year + 1900) - xStrich);
    // cout << "x: "<<x.at(k)<<endl;
    }

//cout <<"------------------------------------3---------------------------"<<endl;

    for (int k = 0; k < x.size(); k++) {
        double tmp;
        tmp = x.at(k);
        tmp = pow(tmp, 2.0);
        xx.push_back(tmp);
     // cout<<xx.at(k)<<endl;
    }
//cout <<"------------------------------------4---------------------------"<<endl;

    SummeXX = xx.at(0);
   //  cout <<"summeXX: "<<SummeXX<<endl;
    for (int k = 1; k < xx.size(); k++) {
        SummeXX = SummeXX + xx.at(k);
     //  cout <<"summeXX: "<<SummeXX<<endl;
    } 
//cout <<"------------------------------------5---------------------------"<<endl;

    y.push_back(daten.at(0).getGewinn() - yStrich);
    for (int k = 0; k < daten.size(); k++) {
        y.push_back(daten.at(k).getGewinn());
      //  cout <<"Gew.: "<<y.at(k)<<endl;
    }
//cout <<"------------------------------------6---------------------------"<<endl;
    for (int k = 0; k < x.size(); k++) {
        xy.push_back(x.at(k) * y.at(k));
      //   cout<<"x*y: "<< xy.at(k)<<endl;
    }
//cout <<"------------------------------------7---------------------------"<<endl;


    SummeXY = xy.at(0);
    for (int k = 1; k < xy.size(); k++) {
        SummeXY = SummeXY + xy.at(k);
 // cout << "SummeXY: " << SummeXY << endl;
    }
    
    
    mGewinnl =  SummeXY /  SummeXX;
  // cout << "Steigung: " <<mGewinnl << " = " << SummeXY << " / " << SummeXX << endl;
    
  //  cout <<"------------------------------------8---------------------------"<<endl;

setBGewinn(xStrich,  yStrich);

    }//ENDE SetMGewinn
   

void Firma::setBGewinn(double xSt, int64_t ySt){

    bGewinnl = xSt*mGewinnl;
    bGewinnl =  ySt-bGewinnl;
    // cout << bGewinnl << " =b" << endl;

 //cout <<"------------------------------------9---------------------------"<<endl;

    }//ENDE SetBGewinn
    
void Firma::setMUmsatz(){

//Durchsnitt Jahre errechnen
   double jahre;
  // 
 jahre = ((double)daten.at(0).getDatum().tm_year) + 1900.0;
    
    for (int k = 1; k < daten.size(); k++) {
      jahre = jahre + ((double)daten.at(k).getDatum().tm_year) + 1900.0;
    }
   
   //cout <<jahre <<" Jahre"<<endl;
    
   double xStrich; // Durchschnitt JAhre
    xStrich = jahre / ((double)daten.size());
   
// Durchschnitt Umsatz errechnen
    int64_t umsatze;
    umsatze = daten.at(0).getUmsatz();
for (int k = 1; k < daten.size(); k++) {
        umsatze = umsatze + daten.at(k).getUmsatz();
    
    }

int64_t yStrich; // Durchschnitt Gewinn
    yStrich = umsatze / daten.size();
     
 
//cout <<"------------------------------------2.1---------------------------"<<endl;
    //lineare Regression M ausrechnen
    vector<double> x; //Jahre - Durschnitt Jahre
    vector<double> xx; //zum Quadrat
    vector<int64_t> y; //Umsatz - Durschnitt Umsatz
    vector<int64_t> xy; // x * y
    
    double SummeXX;
int64_t SummeXY;

    x.push_back((daten.at(0).getDatum().tm_year + 1900) - xStrich);
  //   cout << "x: "<<x.at(0)<<endl;
    for (int k = 1; k < daten.size(); k++) {
        x.push_back((daten.at(k).getDatum().tm_year + 1900) - xStrich);
  //   cout << "x: "<<x.at(k)<<endl;
    }

//cout <<"------------------------------------3.1---------------------------"<<endl;

    for (int k = 0; k < x.size(); k++) {
        double tmp;
        tmp = x.at(k);
        tmp = pow(tmp, 2.0);
        xx.push_back(tmp);
  //    cout<<xx.at(k)<<endl;
    }
//cout <<"------------------------------------4.1---------------------------"<<endl;

    SummeXX = xx.at(0);
  //   cout <<"summeXX: "<<SummeXX<<endl;
    for (int k = 1; k < xx.size(); k++) {
        SummeXX = SummeXX + xx.at(k);
      // cout <<"summeXX: "<<SummeXX<<endl;
    } 
//cout <<"------------------------------------5.1---------------------------"<<endl;

    y.push_back(daten.at(0).getUmsatz() - yStrich);
    for (int k = 0; k < daten.size(); k++) {
        y.push_back(daten.at(k).getUmsatz());
       // cout <<"Gew.: "<<y.at(k)<<endl;
    }
//cout <<"------------------------------------6.1---------------------------"<<endl;
    for (int k = 0; k < x.size(); k++) {
        xy.push_back(x.at(k) * y.at(k));
     //    cout<<"x*y: "<< xy.at(k)<<endl;
    }
//cout <<"------------------------------------7.1---------------------------"<<endl;


    SummeXY = xy.at(0);
    for (int k = 1; k < xy.size(); k++) {
        SummeXY = SummeXY + xy.at(k);
  //cout << "SummeXY: " << SummeXY << endl;
    }
    
    
    mUmsatzl =  SummeXY /  SummeXX;
 //  cout << "Steigung: " <<mUmsatzl << " = " << SummeXY << " / " << SummeXX << endl;
    
    //cout <<"------------------------------------8.1---------------------------"<<endl;

setBUmsatz(xStrich,  yStrich);
    }//ENDE SetMUmsatz
    
void Firma::setBUmsatz(double xSt, int64_t ySt){
bUmsatzl = xSt*mUmsatzl;
    bUmsatzl =  ySt-bUmsatzl;
  //   cout << bUmsatzl << " =b" << endl;

 //cout <<"------------------------------------9.1---------------------------"<<endl;
    }//Ende SetBUmsatz
    
void Firma::setMBilanzsumme(){

//Durchsnitt Jahre errechnen
   double jahre;
  // 
 jahre = ((double)daten.at(0).getDatum().tm_year) + 1900.0;
    
    for (int k = 1; k < daten.size(); k++) {
      jahre = jahre + ((double)daten.at(k).getDatum().tm_year) + 1900.0;
    }
   
  // cout <<jahre <<" Jahre"<<endl;
    
   double xStrich; // Durchschnitt JAhre
    xStrich = jahre / ((double)daten.size());
   
// Durchschnitt Bilanzsumme errechnen
    int64_t bilanzs;
    bilanzs = daten.at(0).getBilanzsumme();
for (int k = 1; k < daten.size(); k++) {
        bilanzs = bilanzs + daten.at(k).getBilanzsumme();
    
    }

int64_t yStrich; // Durchschnitt bilanzsumeme
    yStrich = bilanzs / daten.size();
     
 
//cout <<"------------------------------------2.2---------------------------"<<endl;
    //lineare Regression M ausrechnen
    vector<double> x; //Jahre - Durschnitt Jahre
    vector<double> xx; //zum Quadrat
    vector<int64_t> y; //Bilanzsumme - Durschnitt Bilanzsumme
    vector<int64_t> xy; // x * y
    
    double SummeXX;
int64_t SummeXY;
//Jahre - Durschnitt Jahre
    x.push_back((daten.at(0).getDatum().tm_year + 1900) - xStrich);
    // cout << "x: "<<x.at(0)<<endl;
    for (int k = 1; k < daten.size(); k++) {
        x.push_back((daten.at(k).getDatum().tm_year + 1900) - xStrich);
    // cout << "x: "<<x.at(k)<<endl;
    }

//cout <<"------------------------------------3.2---------------------------"<<endl;
//zum Quadrat
    for (int k = 0; k < x.size(); k++) {
        double tmp;
        tmp = x.at(k);
        tmp = pow(tmp, 2.0);
        xx.push_back(tmp);
   //   cout<<xx.at(k)<<endl;
    }
//cout <<"------------------------------------4.2---------------------------"<<endl;

    SummeXX = xx.at(0);
   //  cout <<"summeXX: "<<SummeXX<<endl;
    for (int k = 1; k < xx.size(); k++) {
        SummeXX = SummeXX + xx.at(k);
    //   cout <<"summeXX: "<<SummeXX<<endl;
    } 
//cout <<"------------------------------------5.2---------------------------"<<endl;
//Bilanzsumme - Durschnitt Bilanzsumme
    y.push_back(daten.at(0).getBilanzsumme() - yStrich);
    for (int k = 0; k < daten.size(); k++) {
        y.push_back(daten.at(k).getBilanzsumme());
      //  cout <<"BilanzS.: "<<y.at(k)<<endl;
    }
//cout <<"------------------------------------6.2---------------------------"<<endl;
    for (int k = 0; k < x.size(); k++) {
        xy.push_back(x.at(k) * y.at(k));
      //   cout<<"x*y: "<< xy.at(k)<<endl;
    }
//cout <<"------------------------------------7.2---------------------------"<<endl;


    SummeXY = xy.at(0);
    for (int k = 1; k < xy.size(); k++) {
        SummeXY = SummeXY + xy.at(k);
 // cout << "SummeXY: " << SummeXY << endl;
    }
    
    
    mBilnazsummel =  SummeXY /  SummeXX;
  // cout << "Steigung: " <<mBilnazsummel << " = " << SummeXY << " / " << SummeXX << endl;
  //  
   // cout <<"------------------------------------8.2---------------------------"<<endl;

setBBilanzsumme(xStrich,  yStrich);

    }//ENDE SetMBilanzsumme
    
void Firma::setBBilanzsumme(double xSt, int64_t ySt){
bBilanzsummel = xSt*mBilnazsummel;
    bBilanzsummel =  ySt-bBilanzsummel;
    // cout << bBilanzsummel << " =b" << endl;

 //cout <<"------------------------------------9.2---------------------------"<<endl;
    }//ENDE SetBBilanzsumme
    
void Firma::setMEigenkapital(){

//Durchsnitt Jahre errechnen
   double jahre;
  // 
 jahre = ((double)daten.at(0).getDatum().tm_year) + 1900.0;
    
    for (int k = 1; k < daten.size(); k++) {
      jahre = jahre + ((double)daten.at(k).getDatum().tm_year) + 1900.0;
    }
   
  // cout <<jahre <<" Jahre"<<endl;
    
   double xStrich; // Durchschnitt JAhre
    xStrich = jahre / ((double)daten.size());
   
// Durchschnitt EK errechnen
    int64_t eks;
    eks = daten.at(0).getEigenkapital();
for (int k = 1; k < daten.size(); k++) {
        eks = eks + daten.at(k).getEigenkapital();
    
    }

int64_t yStrich; // Durchschnitt eks
    yStrich = eks / daten.size();
     
 
//cout <<"------------------------------------2.3---------------------------"<<endl;
    //lineare Regression M ausrechnen
    vector<double> x; //Jahre - Durschnitt Jahre
    vector<double> xx; //zum Quadrat
    vector<int64_t> y; //Ek - Durschnitt EK
    vector<int64_t> xy; // x * y
    
    double SummeXX;
int64_t SummeXY;
//Jahre - Durschnitt Jahre
    x.push_back((daten.at(0).getDatum().tm_year + 1900) - xStrich);
     //cout << "x: "<<x.at(0)<<endl;
    for (int k = 1; k < daten.size(); k++) {
        x.push_back((daten.at(k).getDatum().tm_year + 1900) - xStrich);
     //cout << "x: "<<x.at(k)<<endl;
    }

//cout <<"------------------------------------3.3---------------------------"<<endl;
//zum Quadrat
    for (int k = 0; k < x.size(); k++) {
        double tmp;
        tmp = x.at(k);
        tmp = pow(tmp, 2.0);
        xx.push_back(tmp);
     // cout<<xx.at(k)<<endl;
    }
//cout <<"------------------------------------4.3---------------------------"<<endl;

    SummeXX = xx.at(0);
    // cout <<"summeXX: "<<SummeXX<<endl;
    for (int k = 1; k < xx.size(); k++) {
        SummeXX = SummeXX + xx.at(k);
       //cout <<"summeXX: "<<SummeXX<<endl;
    } 
//cout <<"------------------------------------5.3---------------------------"<<endl;
//ek - Durschnitt ek
    y.push_back(daten.at(0).getEigenkapital() - yStrich);
    for (int k = 0; k < daten.size(); k++) {
        y.push_back(daten.at(k).getEigenkapital());
       // cout <<"EK.: "<<y.at(k)<<endl;
    }
//cout <<"------------------------------------6.3---------------------------"<<endl;
    for (int k = 0; k < x.size(); k++) {
        xy.push_back(x.at(k) * y.at(k));
      //   cout<<"x*y: "<< xy.at(k)<<endl;
    }
//cout <<"------------------------------------7.3---------------------------"<<endl;


    SummeXY = xy.at(0);
    for (int k = 1; k < xy.size(); k++) {
        SummeXY = SummeXY + xy.at(k);
  //cout << "SummeXY: " << SummeXY << endl;
    }
    
    
    mEigenkapitall =  SummeXY /  SummeXX;
  // cout << "Steigung: " <<mEigenkapitall << " = " << SummeXY << " / " << SummeXX << endl;
    
  //  cout <<"------------------------------------8.3---------------------------"<<endl;

setBEigenkapital(xStrich,  yStrich);


    }//ENDE SetMEK

void Firma::setBEigenkapital(double xSt, int64_t ySt){
bEigenkapital = xSt*mEigenkapitall;
    bEigenkapital =  ySt-bEigenkapital;
  //   cout << bEigenkapital << " =b" << endl;

 //cout <<"------------------------------------9.3---------------------------"<<endl;
    }//ENDE SetBEK
    
bool Firma::getLinReg(int i) {
    return daten[i].getVorhersage();
}
    
void Firma::setVorhersage() {
    Finanzen tmp;
    tm date;
    date=daten.at(0).getDatum();
    date.tm_year=date.tm_year+1;
    int64_t umsatz;
    umsatz =lineareRegUmsatz(date.tm_year+1900);
    int64_t gewinn;
    gewinn = lineareRegGewinn(date.tm_year+1900);
    int64_t bilanzsumme;
    bilanzsumme = lineareRegBilanz(date.tm_year+1900);
    int64_t eigenkapital;
    eigenkapital = lineareRegEK(date.tm_year+1900);
    double e, u;
    e = daten[daten.size()-1].getKonv(0);
    u = daten[daten.size()-1].getKonv(1);
    tmp.setAttr(date,umsatz,gewinn,bilanzsumme,eigenkapital,e,u);
    tmp.setVorhersage(true);
    vector<Finanzen> vtmp;
    vtmp.push_back(tmp);
    for (int i = 0; i < daten.size(); i++) {
        vtmp.push_back(daten[i]);
    }
    daten = vtmp;
    setCAGRUmsatz();
    setCAGRGewinn();
        
}


vector<Finanzen> Firma::getFinanzen() {

    return this->daten;

}
int64_t Firma::lineareRegGewinn(int jahr){
    
    int64_t gewinn;
    gewinn = mGewinnl * jahr + bGewinnl; //f(x)=mx+b
    return gewinn;
}

int64_t Firma::lineareRegEK(int jahr){
       
    int64_t ek;
    ek = mEigenkapitall * jahr + bEigenkapital; //f(x)=mx+b
    return ek;
}

int64_t Firma::lineareRegBilanz(int jahr) {
   
    int64_t bilanzsumme;
    bilanzsumme = mBilnazsummel * jahr + bBilanzsummel; //f(x)=mx+b
    return bilanzsumme;

}

int64_t Firma::lineareRegUmsatz(int jahr) {
    
    int64_t umsatz;
    umsatz = mUmsatzl * jahr + bUmsatzl; //f(x)=mx+b
    
    //cout<<"ums.: "<<umsatz<<endl;
//cout<<"--------------------------test1-------------------"<<endl;
return umsatz;
} //Ende linRegUmsatz

void Firma::setCAGRUmsatz() {
//cout<<"-------------------------------------------------test----------------------"<<endl;
    cagru.clear();
    double tmp;
    int64_t umn, uma; // umn=Umsatzn neu ; uma=Umasatz alt
    for (int i = 0; i < daten.size(); i++) {
        int j = i + 3;
        if (j < daten.size()) {
            umn = daten.at(i).getUmsatz();

            uma = daten.at(j).getUmsatz();

            tmp = ((long double) umn) / uma;
            
            double potenz;
            potenz = (1.0 / 3.0);
         
            tmp = pow(tmp, potenz);
            
            tmp = tmp - 1;
            
            cagru.push_back(tmp);
        } else {
            umn = daten.at(i).getUmsatz();
//cout<< "-----------------------------10---------------"<<endl;
            int jahr = daten.at(i).getDatum().tm_year + 1900 - 3;
           
            int64_t umaa;
umaa = lineareRegUmsatz(jahr);
            tmp = ((long double) umn) / umaa;
            
            double potenz;
            potenz = (1.0 / 3.0);
           
            tmp = pow(tmp, potenz);
            tmp = tmp - 1;
            cagru.push_back(tmp);
        }
    }
}


void Firma::setCAGRGewinn() {
    cagrg.clear();
    double tmp, gen, gea; // gen=Gewinn neu ; gea=Gewinn alt
    for (int i = 0; i < daten.size(); i++) {
        int j = i + 3;
        if (j < daten.size()) {
            gen = ((double) daten.at(i).getGewinn());

            gea = ((double) daten.at(j).getGewinn());

            tmp = gen / gea;

            tmp = pow(tmp, (1.0 / 3.0));

            tmp = tmp - 1;
            // cout << "test h " <<tmp<<endl;
            cagrg.push_back(tmp);
        } else {
            gen = daten.at(i).getGewinn();
            int jahr = daten.at(i).getDatum().tm_year + 1900 - 3;
//            cout << "Jahr: " << jahr << endl;
            double geaa = lineareRegGewinn(jahr);
            tmp = ((long double) gen) / geaa;
            //cout << "test"<<tmp<<endl;
            double potenz;
            potenz = (1.0 / 3.0);
            //  cout<<"pot "<<potenz<<endl;
            tmp = pow(tmp, potenz);
            //tmp =tmp^potenz;
            //cout << "teste"<<tmp<<endl;
            tmp = tmp - 1;
            //cout << "testz"<<tmp<<endl;
            cagru.push_back(tmp);
        }
    }
}

/*Firma::Firma(const Firma& orig) {
}*/

Firma::~Firma() {
}



tm Firma::getDatum(int i) {
    return daten.at(i).getDatum();
}

int64_t Firma::getGewinn(int i) {
    if (i < daten.size()) {
        return daten.at(i).getGewinn();
    } else {
        return 0;
    }
}

int64_t Firma::getUmsatz(int i) {
    if (i < daten.size()) {
        return daten.at(i).getUmsatz();
    } else {
        return 0;
    }
}

string Firma::getName() {
    return this->name;
}

int Firma::getAnzahlTage() {
    time_t t, g;
    t = time(NULL);
    tm GJ; //Geschaeftsjahr
    GJ = daten.at(0).getDatum();
    GJ.tm_year = GJ.tm_year + 1;
    g = mktime(&GJ);
    double sec;
    sec = difftime(g, t);
    sec = sec / 60.0;
    sec = sec / 60.0;
    sec = sec / 24.0;
    sec = ceil(sec);
    return sec;
}

int64_t Firma::getBilanzsumme(int i) {
    if (i < daten.size()) {
        return daten.at(i).getBilanzsumme();
    } else {
        return 0;
    }

}

int64_t Firma::getEigenkapital(int i) {
    if (i < daten.size()) {
        return daten.at(i).getEigenkapital();
    } else {
        return 0;
    }
}

double Firma::getEKAnteil(int i) {
    if (i < daten.size()) {
        return daten.at(i).getEKAnteil();
    } else {
        return 0;
    }
}

double Firma::getUmsatzrendite(int i) {
    if (i < daten.size()) {
        return daten.at(i).getUmsatzrendite();
    } else {
        return 0;
    }
}

double Firma::getCAGRUmsatz(int i) {
    if (i < cagru.size()) {
        return cagru.at(i);
    } else {
        return 0.0;
    }
};

double Firma::getCAGRGewinn(int i) {
    if (i < cagrg.size()) {
        return cagrg.at(i);
    } else {
        return 0.0;
    }
};



