/*
 * SWE-Praktikum: Freiburg
 * 
 * Letztes Aenderungsdatum: $Date: 2015-12-06 23:42:32 +0100 (So, 06 Dez 2015) $
 * Letzte  Revision:        $Revision: 1100 $
 * Zuletzt geaendert von:   $Author: stervoir $
 * 
 */


#include <cstdlib>
#include <iostream>
#include <ctime>
#include <iomanip>
#include <ios>

#ifndef FINANZEN_H
#define	FINANZEN_H

using namespace std;

class Finanzen {
public:
    Finanzen();
    Finanzen(tm date, int64_t umsatz, int64_t gewinn, int64_t bilanzsumme, int64_t eigenkapital, double EUR, double USD);
//    finance(const finance& orig);
    virtual ~Finanzen();
    
    void setAttr(tm date, int64_t umsatz, int64_t gewinn, int64_t bilanzsumme, int64_t eigenkapital, double EUR, double USD);
    void testoutput();
    bool getVorhersage();
    int64_t getUmsatz();
    int64_t getGewinn();
    int64_t getBilanzsumme();
    int64_t getEigenkapital();
    double getEKAnteil();
    double getUmsatzrendite();
    double getKonv(int i);
    void setVorhersage(bool a);
    tm getDatum();
private:
    tm date;
    int64_t umsatz = 0;
    int64_t gewinn = 0;
    int64_t bilanzsumme = 0;
    int64_t eigenkapital = 0;
    double konv[2] = {1.0, 1.0};
    bool vorhersage = false;
};

#endif	/* FINANZEN_H */

